LeetCode 16 3Sum Closest(最接近的3个数的和)

简介:

翻译

给定一个有n个整数的数组S,找出S中3个数,使其和等于一个给定的数,target。

返回这3个数的和,你可以假定每个输入都有且只有一个结果。

例如,给定S = {-1 2 1 -4},和target = 1。

那么最接近target的和是2。(-1 + 2 + 1 = 2)。

原文

Given an array S of n integers, 
find three integers in S such that the sum is closest to a given number, target. 

Return the sum of the three integers. 
You may assume that each input would have exactly one solution.

For example, given array S = {-1 2 1 -4}, and target = 1.

The sum that is closest to the target is 2. (-1 + 2 + 1 = 2).

思考

也许我已经开始体会到上一题中别人写的方法的思想了。

在这个题目中,我们要做以下几件事:

  • sort对输入的数组进行排序

  • 求出长度lencurrent之所以要小于len2,是因为后面需要留两个位置给frontback

  • 始终保证front小于back

  • 计算索引为currentfrontback的数的和,分别有比target更小、更大、相等三种情况

  • 更小:如果距离小于close,那么close便等于targetsum,而结果就是sum。更大的情况同理

  • 如果相等,那么要记得将0赋值给closeresult就直接等于target

  • 随后为了避免计算重复的数字,用三个do/while循环递增或递减它们

代码

class Solution
{
public:
    int threeSumClosest(vector<int>& nums, int target) {
        sort(nums.begin(), nums.end());
        int len = nums.size();
        int result = INT_MAX, close = INT_MAX;
        for (int current = 0; current < len - 2; current++) {
            int front = current + 1, back = len - 1;
            while (front < back) {
                int sum = nums[current] + nums[front] + nums[back];
                if (sum < target) {
                    if (target - sum < close) {
                        close = target - sum;
                        result = sum;
                    }
                    front++;
                }
                else if (sum > target) {
                    if (sum - target < close) {
                        close = sum - target;
                        result = sum;
                    }
                    back--;
                }
                else {
                    close = 0;
                    result = target;
                    do {
                        front++;
                    } while (front < back&&nums[front - 1] == nums[front]);
                    do {
                        back--;
                    } while (front < back&&nums[back + 1] == nums[back]);
                }
            }
            while (current < len - 2 && nums[current + 1] == nums[current]) {
                current++;
            }
        }
        return result;
    }
};

和本道题关联密切的题目推荐:

传送门:LeetCode 15 3Sum(3个数的和)
传送门:LeetCode 18 4Sum(4个数的和)

目录
相关文章
|
5月前
|
算法
LeetCode第16题最接近的三数之和
该文章介绍了 LeetCode 第 16 题最接近的三数之和的解法,与第 15 题类似,通过双指针法减少循环次数,根据差值的绝对值来更新最接近的和,并总结了双指针可减少循环次数的要点。
|
5月前
|
Python
【Leetcode刷题Python】16. 最接近的三数之和
解决LeetCode "最接近的三数之和" 问题的Python实现,通过排序和双指针法,记录并更新与目标值最接近的三数之和。
43 1
|
7月前
|
存储 算法 数据挖掘
LeetCode第十六题: 掌握双指针技巧 最接近的三数之和 【python】
LeetCode第十六题: 掌握双指针技巧 最接近的三数之和 【python】
|
8月前
leetcode-16:最接近的三数之和
leetcode-16:最接近的三数之和
62 0
【LeetCode-每日一题】-16. 最接近的三数之和
【LeetCode-每日一题】-16. 最接近的三数之和
|
Java
1657. 确定两个字符串是否接近 --力扣 --JAVA
如果可以使用以下操作从一个字符串得到另一个字符串,则认为两个字符串 接近 : 操作 1:交换任意两个 现有 字符。 例如,abcde -> aecdb 操作 2:将一个 现有 字符的每次出现转换为另一个 现有 字符,并对另一个字符执行相同的操作。 例如,aacabb -> bbcbaa(所有 a 转化为 b ,而所有的 b 转换为 a ) 你可以根据需要对任意一个字符串多次使用这两种操作。 给你两个字符串,word1 和 word2 。如果 word1 和 word2 接近 ,就返回 true ;否则,返回 false 。
47 0
LeetCode: 16. 最接近的三数之和 | 双指针专题
【LeetCode: 16. 最接近的三数之和 | 双指针专题 】
64 1
|
存储 算法 Python
【力扣算法01】之最接近的三数之和
【力扣算法01】之最接近的三数之和
85 0
|
测试技术 C++
力扣16-最接近的三数之和&力扣18-四数之和
力扣16-最接近的三数之和&力扣18-四数之和
91 0
|
算法 安全 Swift
LeetCode - #16 最接近的三数之和
不积跬步,无以至千里;不积小流,无以成江海,Swift社区 伴你前行。如果大家有建议和意见欢迎在文末留言,我们会尽力满足大家的需求。